Небольшая статья о велосипедостроении или о том как я организовал отправку смс средствами asterisk и chan_datacard . Установку пропущу, т.к. она очень детально описана в документации Asterisk_Datacard_Freepbx Сразу отвечу почему не использовал smstools - помимо смс необходимо было совершать и голосовые звонки.

Задача была следующая - с одного сервера отправлять смс с помощью другого, на котором и был настроен asterisk.
Я видел два варианта:
1. С помощью ssh - самый простой вариант, но, как мне показалось, не очень удобный.
2. Написать демон, который будет слушать определенный порт и передавать информацию в asterik. Я остановился на нем.

Сам код. В очередной раз оговорюсь - я не программист и за качество и изящество кода прошу строго не судить.

cat ./serversms
#!/usr/bin/perl -w
use IO::Socket;
use Proc::Daemon;
Proc::Daemon::Init;
my $continue = 1;
my $pidFile = '/var/run/serversms.pid';
my $pid = fork;
if ($pid)
{
open PIDFILE, ">$pidFile" or die "can't open $pidFile: $!\n";
print PIDFILE $pid;
close PIDFILE;
exit 0;
}
$SIG{TERM} = sub { $continue = 0 };
while ($continue) {
#порт на котором будем принимать данные
my $port = 3333;
socket(SOCK, PF_INET,SOCK_STREAM, getprotobyname('tcp')) or die ("Dont create socket!");
setsockopt(SOCK, SOL_SOCKET, SO_REUSEADDR, 1);
my $paddr = sockaddr_in($port, INADDR_ANY);
bind(SOCK, $paddr) or die("dont lock port!");
listen(SOCK, SOMAXCONN);
while (my $client_addr = accept(CLIENT, SOCK)){
my ($client_port, $client_ip) = sockaddr_in($client_addr);
my $client_ipnum = inet_ntoa($client_ip);
my $client_host = gethostbyaddr($client_ip, AF_INET);
my $data;
my $count = sysread(CLIENT, $data, 1024);
my @words=split(/\s+/, $data);
my $text='';
for(my $i=1; $i<@words; $i++) {
$text=$text.' '.$words[$i];
}
my $sms_number = $words[0];
#проверяем на соответствие номера нашим требованиям
$sms_number =~ s/\D+//g;
if (length ($sms_number) < 10) {
print CLIENT "error number!";
}
#Если нет префикса страны, добавляем, т.к. в противном случае смс отправлено не будет
if (length ($sms_number) == 10) {
$sms_number= '38'.$sms_number;
}
$text =~s/_/ /g;
#Передаем наши данные астериску
$result = `/usr/sbin/asterisk -rx \"datacard sms datacard0 $sms_number $text\"`;
$send_result = substr ($result,-10);
#и возвращаем клиенту ID отправленной смс
print CLIENT "$send_result";
close(CLIENT);
}
}

Разберемся, что делать с полученным ID. Как убедиться, что смс все же была отправлена? Для этого я создал очередной костыль:

cat ./checksms
#!/usr/bin/perl -w
use IO::Socket;
use Proc::Daemon;
Proc::Daemon::Init;
my $continue = 1;
my $pidFile = '/var/run/checksms.pid';
my $pid = fork;
if ($pid)
{
open PIDFILE, ">$pidFile" or die "can't open $pidFile: $!\n";
print PIDFILE $pid;
close PIDFILE;
exit 0;
}
$SIG{TERM} = sub { $continue = 0 };
while ($continue) {
#порт на котором слушаем запросы о проверке статуса смс
my $port = 3334;
socket(SOCK, PF_INET,SOCK_STREAM, getprotobyname('tcp')) or die ("Dont create socket!");
setsockopt(SOCK, SOL_SOCKET, SO_REUSEADDR, 1);
my $paddr = sockaddr_in($port, INADDR_ANY);
bind(SOCK, $paddr) or die("dont lock port!");
listen(SOCK, SOMAXCONN);
while (my $client_addr = accept(CLIENT, SOCK)){
my ($client_port, $client_ip) = sockaddr_in($client_addr);
my $client_ipnum = inet_ntoa($client_ip);
my $client_host = gethostbyaddr($client_ip, AF_INET);
my $data;
my $count = sysread(CLIENT, $data, 1024);
my @words=split(/\s+/, $data);
my $sms_id = $words[0];
my $find=0;
#я использовал следующие статусы
#2 - не отправлено
#3 - отправлено
my $sendstatus=2;
#данные берем из логов астериска
open my $asterisklog, '<', '/var/log/asterisk/message' or die "Can't open log file: $!";
while (<$asterisklog>)
{
if(/$sms_id/) {
if (/Successfully/){
$find=1;
}
};
}
if ($find == 1) {
$sendstatus=3;
}
close ($asterisklog);
print CLIENT "$sendstatus\n";
close(CLIENT);
}
}

скрипты копируем в /usr/local/bin
теперь создадим init-скрипты которые будут управлять нашими процессами:

#! /bin/sh
### BEGIN INIT INFO
# Provides: smssend
# Required-Start: $remote_fs $syslog
# Required-Stop: $remote_fs $syslog
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: smsend
# Description: This file should be used to construct scripts to be
# placed in /etc/init.d.
### END INIT INFO
PATH=/sbin:/usr/sbin:/bin:/usr/bin:/usr/local/bin
DESC="sms send"
NAME=serversms
DAEMON=/usr/local/bin/$NAME
DAEMON_ARGS="--options args"
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME
# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0
# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME
# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh
# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions
#
# Function that starts the daemon/service
#
do_start()
{
# Return
# 0 if daemon has been started
# 1 if daemon was already running
# 2 if daemon could not be started
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
|| return 1
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
$DAEMON_ARGS \
|| return 2
# Add code here, if necessary, that waits for the process to be ready
# to handle requests from services started subsequently which depend
# on this one. As a last resort, sleep for some time.
}
#
# Function that stops the daemon/service
#
do_stop()
{
# Return
# 0 if daemon has been stopped
# 1 if daemon was already stopped
# 2 if daemon could not be stopped
# other if a failure occurred
start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
RETVAL="$?"
[ "$RETVAL" = 2 ] && return 2
# Wait for children to finish too if this is a daemon that forks
# and if the daemon is only ever run from this initscript.
# If the above conditions are not satisfied then add some other code
# that waits for the process to drop all resources that could be
# needed by services started subsequently. A last resort is to
# sleep for some time.
start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
[ "$?" = 2 ] && return 2
# Many daemons don't delete their pidfiles when they exit.
rm -f $PIDFILE
return "$RETVAL"
}
#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
#
# If the daemon can reload its configuration without
# restarting (for example, when it is sent a SIGHUP),
# then implement that here.
#
start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
return 0
}
case "$1" in
start)
[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
do_start
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
;;
stop)
[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
do_stop
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
;;
status)
status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
;;
#reload|force-reload)
#
# If do_reload() is not implemented then leave this commented out
# and leave 'force-reload' as an alias for 'restart'.
#
#log_daemon_msg "Reloading $DESC" "$NAME"
#do_reload
#log_end_msg $?
#;;
restart|force-reload)
#
# If the "reload" option is implemented then remove the
# 'force-reload' alias
#
log_daemon_msg "Restarting $DESC" "$NAME"
do_stop
case "$?" in
0|1)
do_start
case "$?" in
0) log_end_msg 0 ;;
1) log_end_msg 1 ;; # Old process is still running
*) log_end_msg 1 ;; # Failed to start
esac
;;
*)
# Failed to stop
log_end_msg 1
;;
esac
;;
*)
#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
exit 3
;;
esac
:

По аналогии создаем такой же скрипт и для второй программы.
после чего стартуем и проверяем слушают ли они указанные нами порты:

#/etc/init.d/smssend start
#/etc/init.d/smscheck start
# lsof -i:3333-3334
COMMAND PID USER FD TYPE DEVICE SIZE/OFF NODE NAME
serversms 6934 root 3u IPv4 278283879 0t0 TCP *:3333 (LISTEN)
checksms 25677 root 3u IPv4 266217061 0t0 TCP *:3334 (LISTEN)

если вывод аналогичный этому, следовательно все в порядке.
Несколько слов о безопасности. Как вы можете видеть никакой проверки подключаемого клиента не производится. Мне необходимо было дать доступ только для одного IP, поэтому я просто закрыл порты на сервере и разрешил только для используемого IP

#iptables -A INPUT -p tcp -m multiport --dports 3333,3334 -j DROP
#iptables -I INPUT -s IP -p tcp -m multiport --dports 3333,3334 -j ACCEPT

Или включить проверку в самом скрипте - для чего можно использовать переменную $client_host и проверять ее на соответствие необходимым адресам.

Для входящих смс я немного видоизменил правило астериска, мне нужно было не складывать текст в один файл, а перенаправлять его на почту. Как оказалось в функции System нельзя использовать пайпы "|". Для выхода из ситуации я не придумал ничего лучшего как еще один костыль:

cat /usr/local/bin/inssms.pl
#!/usr/bin/perl
if(!defined $ARGV[0]){
print "No data specified\n";
exit;
}
if(!defined $ARGV[1]){
print "No number specified\n";
exit;
}
if(!defined $ARGV[2]){
print "No text specified\n";
exit;
}
$result = `echo "$ARGV[0] $ARGV[2]" | mail -a 'MIME-Version: 1.0' -a 'Content-Type: text/plain; charset=utf-8' -s 'sms from $ARGV[1]' me\@mydomain -- -f sms\@mydomain`

и правило в extensions_custom.conf у меня приняло вид:

exten => sms,n,System(/usr/local/bin/inssms.pl ${STRFTIME(${EPOCH},,%Y-%m-%d_%H:%M:%S)} ${CALLERID(num)} '${SMS}' )

Вот такое не очень красивое, но работающее решение.
Буду рад, если кто-то посчитает эту информацию полезной